import sdl2
import sdl2.ext
import sdl2.sdlmixer

class Mixer:
    def __init__(self, file, volume = 1.0):
        self.file = file
        self.volume = volume

        sdl2.SDL_Init(sdl2.SDL_INIT_AUDIO)

        sdl2.sdlmixer.Mix_OpenAudio(44100, sdl2.sdlmixer.MIX_DEFAULT_FORMAT, 2, 1024)

        self.music = sdl2.sdlmixer.Mix_LoadMUS(self.file.encode())

        sdl2.sdlmixer.Mix_VolumeMusic(int(self.volume * 128))

    def play(self, loop = 0):
        sdl2.sdlmixer.Mix_PlayMusic(self.music, loop)

    def stop(self):
        sdl2.sdlmixer.Mix_HaltMusic()

    def pause(self):
        sdl2.sdlmixer.Mix_PauseMusic()

    def resume(self):
        sdl2.sdlmixer.Mix_ResumeMusic()

    def set_volume(self, volume):
        self.volume = volume
        sdl2.sdlmixer.Mix_VolumeMusic(int(self.volume * 128))

    def set_pos(self, pos):
        sdl2.sdlmixer.Mix_SetMusicPosition(pos)

    def fade_in(self, duration = 1000, loop = 0):
        sdl2.sdlmixer.Mix_FadeInMusic(self.music, loop, duration)

    def fade_out(self, duration = 1000):
        sdl2.sdlmixer.Mix_FadeOutMusic(duration)